Subject: Re: [mpls-tp] If a PW is a sublayer, why is it different?

From: "Shahram Davari" <[email-masked]>
Date: Thu, 29 Oct 2009 09:43:34 -0700

Hi sasha 

The GAL rfc says it must not be used for PW 

Shahram

----- Original Message -----
From: [email-masked] <[email-masked]>
To: Adrian Farrel <[email-masked]>; Luca Martini <[email-masked]>
Cc: [email-masked] <[email-masked]>
Sent: Wed Oct 28 22:34:25 2009
Subject: Re: [mpls-tp] If a PW is a sublayer, why is it different?

Adrian, Luca and all,
I agree with Adrian: data plane-wise S-PE is not different from P.

The differences come with the control plane (which may be absent in MPLS-TP)
or with OAM which, AFAIK, has not yet been standardized for MS-PWs and which, 
in an case, may be also absent the operator's choice. 

On the other hand, when it comes to OAM, the answer to the original question IMHO has a
very practical implication:

If I want to run OAM in an MS-PW that runs in an MPLS-TP network, do I have 
to use GAL as the last label in the label stack and followed by the ACH header
(as defined in RFC 5586), or can I run it using VCCV (as defined in RFC 5085)?

My 2c,
     Sasha

> -----Original Message-----
> From: [email-masked] 
> [mailto:[email-masked]] On Behalf Of Adrian Farrel
> Sent: Thursday, October 29, 2009 1:53 AM
> To: Luca Martini
> Cc: [email-masked]
> Subject: Re: [mpls-tp] If a PW is a sublayer, why is it different?
> 
> Luca,
> 
> Perhaps I didn't explain my question clearly enough.
> 
> In the data plane of an MPLS-TP network (so it is all one 
> server type - 
> MPLS-TP), is there any difference in behavior in an S-PE and 
> P node when 
> switching packets?
> 
> Let me draw a network...
> 
> 
> A==B==C***D***E
> 
> Consider that I build two LSP tunnels ABC and CDE.
> Now suppose I want an LSP (note: not a PW) form A to E. It 
> runs ACE using 
> the two tunnels.
> At C, when a packet is received, the top label is popped (end 
> of LSP ABC) 
> and the exposed label is used for forwarding. Then a new 
> label is imposed 
> (LSP CDE) before the packet is sent onward.
> 
> Now, let me draw another network.
> 
> A==B==C***D***E
> 
> Consider that I build two LSP tunnels ABC and CDE.
> Now suppose I want a PW (note: not an LSP) form A to E. It 
> runs ACE using 
> the two tunnels.
> At C, when a packet is received, the top label is popped (end 
> of LSP ABC) 
> and the exposed label is used for forwarding. Then a new 
> label is imposed 
> (LSP CDE) before the packet is sent onward.
> 
> In the first case, node C is a P-node.
> In the second case, node C is an S-PE.
> There is nothing that precludes or requires node C to be on 
> any domain 
> boundary.
> 
> What is the difference in the data plane between node C in 
> the first case 
> and node C in the second case?
> 
> It is important (to me) to limit this question to the data 
> plane. I don't 
> care how the LSPs or PWs are set up or what service they are 
> delivering.
> 
> Thanks,
> Adrian
> 
> ----- Original Message ----- 
> From: "Luca Martini" <[email-masked]>
> To: "Adrian Farrel" <[email-masked]>
> Cc: <[email-masked]>
> Sent: Wednesday, October 28, 2009 10:31 PM
> Subject: Re: [mpls-tp] If a PW is a sublayer, why is it different?
> 
> > Hi Adrian,
> >
> > An S-PE is very different. A P node has no knowledge of 
> what is in the PW, 
> > what specific parameters are incompatible with the 2 PWs. 
> block or fake PW 
> > OAM, etc...
> > An S-PE is an administrative , and control point for the 
> MS-PW. While a P 
> > Router switches all LSP the same , and does not even have 
> to be a MIP.
> > Also an S-PE can connect PWs running on completely different server 
> > networks, without any interworking function at the network layer.
> >
> > Luca
> >
> >
> >
> > Adrian Farrel wrote:
> >> So trying to take this a step further...
> >>
> >> If a PW is "just a label" making it "just a sub-layer" why 
> do we insist 
> >> that it is in any way different within the network?
> >>
> >> How is an S-PE that switches PW segments any different 
> from a P-node that 
> >> switches LSP segments? True, the S-PE must terminate the 
> LSP tunnel (pop 
> >> a label) before finding the PW label on which to switch. 
> But this same 
> >> function could apply at a P-node that is switching an LSP that was 
> >> carried in a tunnel.
> >>
> >
> >> If this is the case, shouldn't we *include* PWs in the 
> Survivability 
> >> Framework:
> >> - as automatically the same as LSPs
> >> - with some examples to show how the function if achieved.
> >>
> >> To repeat: How are PWs any different within the network.
> >>
> >
> >> [In answering, please recall that we are talking about 
> MPLS-TP networks 
> >> only.]
> >>
> >> Thanks,
> >> Adrian
> >>
> >> ----- Original Message ----- From: "David Allan I" 
> >> <[email-masked]>
> >> To: "Sprecher, Nurit (NSN - IL/Hod HaSharon)" 
> <[email-masked]>; 
> >> <[email-masked]>
> >> Sent: Wednesday, October 28, 2009 4:41 PM
> >> Subject: Re: [mpls-tp] Is PW a layer of MPLS-TP
> >>
> >>
> >>> Hi Nurit:
> >>>
> >>> I think you misunderstand me. My comment on whether we 
> supported clients 
> >>> besides PWs was to illustrate second order consequences, 
> not to suggest 
> >>> that OAM was wagging the dog or was involved in 
> delineation of layers 
> >>> and sublayers...
> >>>
> >>> IMO all labels between the link layer preamble and the 
> label with the S- 
> >>> bit set are either reserved functions or sub-layers of 
> the MPLS-TP 
> >>> "layer", "sub-layers" AND reserved labels being what was known as 
> >>> "levels" in RFC 3031. All sub layers have the potential 
> to be switched 
> >>> including the PW sub-layer, ergo a PW is a sub-layer of MPLS-TP...
> >>>
> >>> I hope I'm clear...
> >>>
> >>> Cheers
> >>> D
> >>>
> >>> -----Original Message-----
> >>> From: Sprecher, Nurit (NSN - IL/Hod HaSharon) 
> >>> [mailto:[email-masked]]
> >>> Sent: Wednesday, October 28, 2009 12:27 PM
> >>> To: David Allan I; [email-masked]
> >>> Subject: RE: [mpls-tp] Is PW a layer of MPLS-TP
> >>>
> >>> Hi Dave,
> >>> I am afraid again that relying on OAM to distinnguish between the 
> >>> clients is a wrong approach.
> >>> Best regadrs,
> >>> Nurit
> >>>
> >>> -----Original Message-----
> >>> From: [email-masked] 
> [mailto:[email-masked]] On 
> >>> Behalf Of ext David Allan I
> >>> Sent: Wednesday, October 28, 2009 6:02 PM
> >>> To: [email-masked]
> >>> Subject: [mpls-tp] Is PW a layer of MPLS-TP
> >>>
> >>> HI Adrian:
> >>>
> >>> IMO the S-bit is set in the PW label and clear in the 
> encapsulating 
> >>> sub-layers, hence it is a sub-layer in the G.805 sense of MPLS-TP.
> >>>
> >>> IMO it does confuse the landscape as OAM discrimination 
> requires apriori 
> >>> knowledge of the label type at bottom of stack IF we 
> assume a BOS can be 
> >>> other than a PW...
> >>>
> >>> My 2 cents
> >>> D
> >>>
> >>> You wrote>>>>
> >>>
> >>> Hi,
> >>>
> >>> I am trying this question again with a different subject line.
> >>>
> >>>
> >>> It would be helpful to have more answers than just Neil's 
> (not that I 
> >>> don't value his view, but one person doesn't make consensus!)
> >>>
> >>> My question:
> >>>
> >>> Hasn't the work on the MPLS-TP Framework draft judged PW 
> to be a client 
> >>> of MPLS-TP?
> >>> That is, PW is not a layer of MPLS-TP, but the client.
> >>>
> >>> Doesn't that mean that PW survivability is out of scope 
> for the MPLS-TP 
> >>> Survivability I-D?
> >>>
> >>> Thanks,
> >>> Adrian
> >>> _______________________________________________
> >>> mpls-tp mailing list
> >>> [email-masked]
> >>> https://www.ietf.org/mailman/listinfo/mpls-tp
> >>> _______________________________________________
> >>> mpls-tp mailing list
> >>> [email-masked]
> >>> https://www.ietf.org/mailman/listinfo/mpls-tp
> >>>
> >>
> >> _______________________________________________
> >> mpls-tp mailing list
> >> [email-masked]
> >> https://www.ietf.org/mailman/listinfo/mpls-tp
> >
> > 
> 
> _______________________________________________
> mpls-tp mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/mpls-tp
> 
_______________________________________________
mpls-tp mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/mpls-tp

---

From: Alexander Vainshtein <[email-masked]>
Date: Thu, 29 Oct 2009 21:57:02 +0200

Shaharam,
You are right, of course, thank you for the clarification.
This can be used as an explanation (of sorts) why PW sub-layer is different.

Now let me ask you the following question.

Suppose (just suppose) I am running a L3 VPN on top of MPLS-TP and want to
run some kind of data plane OAM between a pair of VRFs in a given L3 VPN 
instance.

Should I do that using GAL or using VCCV? Or do I have to invent a
new mechanism for this purpose because these packets are neither PWs
nor MPLS-TP LSPs?

(The answer would be simple in the case of VPLS, because VSIs are
interconnected over PWs. But L3 VPNs historically preceded PWs, 
so they do not use them.)

My 2c,
     Sasha

> From: Shahram Davari [mailto:[email-masked]] 
> Sent: Thursday, October 29, 2009 6:44 PM
> To: Alexander Vainshtein; [email-masked]'; [email-masked]'
> Cc: [email-masked]'

---

From: <[email-masked]>
Date: Thu, 29 Oct 2009 21:35:31 -0000

Sasha,

I'll say it again because I would really like to avoid as many arch
errors as possible whilst we are still specifying/standardising MPLS-TP
(I'll assumes it's not done deal yet ;-)).... the DP OAM of MPLS-TP
should NOT appear under the GAL.  The GAL ought to be reserved for CP/MP
protocols only and it should never appear in the traffic DP....but it
will if it is used for OAM because OAM should be generated/terminated at
the trail termination points of MPLS-TPs and these are most definitely
in the traffic DP.  Further, by applying the GAL to DP OAM and not DP
traffic units we do not have close alignment between OAM and traffic
header structures....and that is pretty bad protocol design IMO.

Is it really too late now to get this done right?  And are we really
going to waste 8 bits (ie 25%) of very scarce MPLS traffic unit header
on a redundant TTL function?....the CP/MP MUST verify a connection has
no loops before it can be established, just like all other co-cs/ps
technologies do, including those using a GMPLS CP!   

If we are then we should state the real commercial and/or political
reasons that are forcing this mistake to be made in MPLS-TP ...because
it sure as anything does not stack-up technically.

regards, Neil  
> [mailto:[email-masked]] On Behalf Of Alexander Vainshtein
> Sent: 29 October 2009 19:57
> To: Shahram Davari
> Cc: [email-masked]'
> Suppose (just suppose) I am running a L3 VPN on top of 
> MPLS-TP and want to run some kind of data plane OAM between a 
> pair of VRFs in a given L3 VPN instance.
> 
> Should I do that using GAL or using VCCV? Or do I have to 
> invent a new mechanism for this purpose because these packets 
> are neither PWs nor MPLS-TP LSPs?
> 
> (The answer would be simple in the case of VPLS, because VSIs 
> are interconnected over PWs. But L3 VPNs historically 
> preceded PWs, so they do not use them.)
> 
> My 2c,
>      Sasha
> 
> > The differences come with the control plane (which may be absent in 
> > MPLS-TP) or with OAM which, AFAIK, has not yet been 
> standardized for 
> > MS-PWs and which, in an case, may be also absent the operator's 
> > choice.
> > 
> > On the other hand, when it comes to OAM, the answer to the original 
> > question IMHO has a very practical implication:
> > 
> > If I want to run OAM in an MS-PW that runs in an MPLS-TP 
> network, do I 
> > have to use GAL as the last label in the label stack and 
> followed by 
> > the ACH header (as defined in RFC 5586), or can I run it using VCCV 
> > (as defined in RFC 5085)?
> > 
> > My 2c,
> >      Sasha
> >  
> > 
> > > In the data plane of an MPLS-TP network (so it is all one server 
> > > type - MPLS-TP), is there any difference in behavior in 
> an S-PE and 
> > > P node when switching packets?
> > > 
> > > Let me draw a network...
> > > 
> > > 
> > > A==B==C***D***E
> > > 
> > > Now suppose I want an LSP (note: not a PW) form A to E. 
> It runs ACE 
> > > using the two tunnels.
> > > At C, when a packet is received, the top label is popped 
> (end of LSP 
> > > ABC) and the exposed label is used for forwarding. Then a 
> new label 
> > > is imposed (LSP CDE) before the packet is sent onward.
> > > 
> > > Now suppose I want a PW (note: not an LSP) form A to E. 
> It runs ACE 
> > > using the two tunnels.
> > > At C, when a packet is received, the top label is popped 
> (end of LSP 
> > > ABC) and the exposed label is used for forwarding. Then a 
> new label 
> > > is imposed (LSP CDE) before the packet is sent onward.
> > > 
> > > There is nothing that precludes or requires node C to be on any 
> > > domain boundary.
> > > 
> > > What is the difference in the data plane between node C 
> in the first 
> > > case and node C in the second case?
> > > 
> > > It is important (to me) to limit this question to the 
> data plane. I 
> > > don't care how the LSPs or PWs are set up or what service 
> they are 
> > > delivering.
> > > 
> > > Thanks,
> > > Adrian
> > >

---

From: Maarten Vissers <[email-masked]>
Date: Thu, 29 Oct 2009 23:18:22 +0100

Sasha,

A L3VPN is a transport entity in the IP layer network. You have to use IP
OAM to monitor it.

Regards,
Maarten 

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf
Of Alexander Vainshtein
Sent: donderdag 29 oktober 2009 20:57
To: Shahram Davari
Cc: [email-masked]'
Subject: Re: [mpls-tp] If a PW is a sublayer, why is it different?

Shaharam,

Should I do that using GAL or using VCCV? Or do I have to invent a new
mechanism for this purpose because these packets are neither PWs nor MPLS-TP
LSPs?

(The answer would be simple in the case of VPLS, because VSIs are
interconnected over PWs. But L3 VPNs historically preceded PWs, so they do
not use them.)

My 2c,
     Sasha

> MPLS-TP) or with OAM which, AFAIK, has not yet been standardized for 
> If I want to run OAM in an MS-PW that runs in an MPLS-TP network, do I 
> have to use GAL as the last label in the label stack and followed by 
> > type - MPLS-TP), is there any difference in behavior in an S-PE and 
> > Now suppose I want an LSP (note: not a PW) form A to E. It runs ACE 
> > using the two tunnels.
> > At C, when a packet is received, the top label is popped (end of LSP 
> > ABC) and the exposed label is used for forwarding. Then a new label 
> > Now suppose I want a PW (note: not an LSP) form A to E. It runs ACE 
> > using the two tunnels.
> > At C, when a packet is received, the top label is popped (end of LSP 
> > ABC) and the exposed label is used for forwarding. Then a new label 
> > What is the difference in the data plane between node C in the first 
> > It is important (to me) to limit this question to the data plane. I 
> > don't care how the LSPs or PWs are set up or what service they are 
> > delivering.
> > 
> > Thanks,
> > Adrian
> >

---

From: Maarten Vissers <[email-masked]>
Date: Fri, 30 Oct 2009 08:44:55 +0100

Sasha,

> are interconnected over PWs. But L3 VPNs historically preceded PWs,

VPLS is another name for an Ethernet VLAN. 
In VPLS you use Ethernet OAM (Y.1731, 802.1ag).

VSIs are typically interconnected by tunnel LSPs, in which the SS-PW
provides a label stack entry header that replaces the normal VLAN Tag
header. The LSP OAM monitors as such the status of the tunnel and the
Ethernet OAM monitors the status of the VLAN/VPLS.

Regards,
Maarten

-----Original Message-----

Shaharam,

My 2c,
     Sasha

---

From: Alexander Vainshtein <[email-masked]>
Date: Fri, 30 Oct 2009 12:26:28 +0200

Maarten,
IMHO and FWIW, VPLS is NOT another name for Ethernet VLAN.
The most obvious difference in the data plane is a combination of
a full mesh of PWs between the peer VSIs and the Split Horizon mechanism for loop
prevention. (In the native Ethernet VLAN you MUST run some form of STP for loop
prevention.)

Regards,
     Sasha
________________________________________
From: Maarten Vissers [[email-masked]]
Sent: Friday, October 30, 2009 9:44 AM
To: Alexander Vainshtein
Cc: [email-masked]
Subject: RE: [mpls-tp] If a PW is a sublayer, why is it different?

Sasha,

Regards,
Maarten

-----Original Message-----

Shaharam,

My 2c,
     Sasha

---

From: "Sprecher, Nurit (NSN - IL/Hod HaSharon)" <[email-masked]>
Date: Fri, 30 Oct 2009 11:40:01 +0100

Correct.
Ethernet is by nature a MP2MP data-plane. 
VPLS is a service where Ethernet frames are delivered over a full-mesh
of P2P paths. 

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On
Behalf Of ext Alexander Vainshtein
Sent: Friday, October 30, 2009 12:26 PM
To: Maarten Vissers
Cc: [email-masked]
Subject: Re: [mpls-tp] If a PW is a sublayer, why is it different?

Maarten,
IMHO and FWIW, VPLS is NOT another name for Ethernet VLAN.
The most obvious difference in the data plane is a combination of
a full mesh of PWs between the peer VSIs and the Split Horizon mechanism
for loop
prevention. (In the native Ethernet VLAN you MUST run some form of STP
for loop
prevention.)

Regards,
     Sasha

Sasha,

Regards,
Maarten

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On
Behalf
Of Alexander Vainshtein
Sent: donderdag 29 oktober 2009 20:57
To: Shahram Davari
Cc: [email-masked]'
Subject: Re: [mpls-tp] If a PW is a sublayer, why is it different?

Shaharam,
You are right, of course, thank you for the clarification.
This can be used as an explanation (of sorts) why PW sub-layer is
different.

Suppose (just suppose) I am running a L3 VPN on top of MPLS-TP and want
to
run some kind of data plane OAM between a pair of VRFs in a given L3 VPN
instance.

Should I do that using GAL or using VCCV? Or do I have to invent a new
mechanism for this purpose because these packets are neither PWs nor
MPLS-TP
LSPs?

(The answer would be simple in the case of VPLS, because VSIs are
interconnected over PWs. But L3 VPNs historically preceded PWs, so they
do
not use them.)

My 2c,
     Sasha

---

From: Maarten Vissers <[email-masked]>
Date: Fri, 30 Oct 2009 14:02:11 +0100

Sasha,

An Ethernet VLAN is a n-port (n>=2) transport entity in which there is one
path between any of the input ports to any of the output ports. There are
multiple topologies that support this single path principle. One of the
topologies is a tree-structured VLAN, another topology is an emulated
tree-structured VLAN that contains a full mesh of link connections between a
subset of the bridge functions and use split-horizon to emulate the single
path principle. One VLAN may consist of tree-structured parts and full mesh
parts.

A VLAN/VPLS instance is modelled as a transport entity in the ETH layer
network. You find examples of both VLAN/VPLS topologies and the hybrid
topology presented in G.8011.5. 

xSTP + xVRP are two VLAN connection management related control protocols
with which it is possible to configure a tree-structured VLAN in the nodes
within the xSTP/xVRP domain. The alternative VLAN connection management
methods are using NMS or ASON/GMPLS (instead of xSTP/xVRP). With NMS or
ASON/GMPLS it is possible to configure not only tree-structured but also
full mesh and hybrid topology based VLANs/VPLSs. NMS or ASON/GMPLS are
responsible to create the VLAN/VPLS without loops.

The VLAN connection management method however does not have any impact on
the VLAN itself, nor on its OAM. Tree-structured, full mesh or hybrid
topology type VLAN/VPLSs are monitored by Ethernet OAM.

Note that split-horizon functionality is supported by an extension of the
primary filtering rule within a VLAN. The primary filtering rule in a VLAN
is that a frame ingressing on port X can be output on all ports of that VLAN
with the exception of port X. Split-horizon extends this primary filtering
rule to a port group; i.e. a frame ingresssing on port Xi, i=1 can be output
on all ports of that VLAN with the exception of the ports Xi (i=1..n) within
port group X. In the examples in G.8011.5 you find these split-horizon port
groups being indicated in the figures 6-3, 6-4, 6-5 and 6-6.

Regards,
Maarten

-----Original Message-----
From: Alexander Vainshtein [mailto:[email-masked]] 
Sent: vrijdag 30 oktober 2009 11:26
To: Maarten Vissers
Cc: [email-masked]
Subject: RE: [mpls-tp] If a PW is a sublayer, why is it different?

Maarten,
IMHO and FWIW, VPLS is NOT another name for Ethernet VLAN.
The most obvious difference in the data plane is a combination of a full
mesh of PWs between the peer VSIs and the Split Horizon mechanism for loop
prevention. (In the native Ethernet VLAN you MUST run some form of STP for
loop
prevention.)

Regards,
     Sasha

Sasha,

> interconnected over PWs. But L3 VPNs historically preceded PWs, so 
> they do not use them.)

Regards,
Maarten

-----Original Message-----

Shaharam,

My 2c,
     Sasha

_______________________________________________
mpls-tp mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/mpls-tp=

---

From: Alexander Vainshtein <[email-masked]>
Date: Sat, 31 Oct 2009 14:05:11 +0200

Neil,
IMHO and FWIW - yes, it is too late to try to make MPLS-TP data plane different from 
that of MPLS. Please see Requirement #1 in RFC 5654. This includes, among other things, TTL
processing.

I must admit that I do not see why using GAL and ACH header in the OAM flows is
problematic. Please remember, that, in full accordance with the MPLS data plane rules,
GAL shall be looked at only by the node that has popped/terminated all the labels above it 
in the label stack. Hence OAM shall be indeed initiated and terminated at the trail termination
points of MPLS-TP "trails".

Last but not least, I believe that, within the MPLS data plane, there are just two ways
to implement the traceroute function:
- by sending a sequence of packets with increasing TTL of the top label starting with 2
- by placing the "router alert" label on top of the label stack of every "tracing" packet.

My 2c,
     Sasha

________________________________________
From: [email-masked] [[email-masked]]
Sent: Thursday, October 29, 2009 11:35 PM
To: Alexander Vainshtein; [email-masked]
Cc: [email-masked]
Subject: RE: [mpls-tp] If a PW is a sublayer, why is it different?

Sasha,

regards, Neil